#!/bin/env python

# this script updates /etc/yum.conf:
# 1) repositories from LCG_REPOSITORY
# 2) repositories frpm CA_REPOSITORY
# 3) adds CERN SLC 30x repositories for additional packages

import os
import sys
import ConfigParser


lcg_rep = os.environ.get('LCG_REPOSITORY')
CA_rep  = os.environ.get('CA_REPOSITORY')

lcg_split = lcg_rep.split(' ')
lcg_split[0] = 'LCG'
CA_split  = CA_rep.split(' ')
CA_split[0] = 'CA'

repositories = [lcg_split,CA_split]

# now add the CERN SLC 30x repositories
repositories.append('SLC30X http://linuxsoft.cern.ch cern/slc30X/i386/apt os updates extras'.split(' '))

# not necessary - disabled for now
#if ( (os.uname()[4]=='x86_64') | (os.uname()[4]=='ia64') ):
#    repositories.append(('SLC30X.'+os.uname()[4]+' http://linuxsoft.cern.ch cern/slc30X/'+os.uname()[4]+'/apt os updates extras').split(' '))

# backup, then read the existing config
try:
    os.system('cp /etc/yum.conf /etc/yum.conf.yaimbak')
except:
    print ("cp failed")
    
yumconf = ConfigParser.ConfigParser()
try:
    yumconf.read('/etc/yum.conf')
except:
    print ("no yum.conf found - creating default file!")

for split in repositories:
    for nr in split[3:]:
        baseurl = split[1]+'/'+split[2]+'/RPMS.'+nr
        name    = split[0]+' '+nr
        section = split[0]+'.'+nr

        if not yumconf.has_section(section):
            # print 'section ' + section + ' not found'
            yumconf.add_section(section)

        yumconf.set(section,'name',name)
        yumconf.set(section,'baseurl',baseurl)
        yumconf.set(section,'gpgcheck',0)

# is section [main] present? If not, create one with defaults(?)
if not yumconf.has_section('main'):
    yumconf.add_section('main')
    yumconf.set('main','cachedir','/var/cache/yum')
    yumconf.set('main','debuglevel','2')
    yumconf.set('main','logfile','/var/log/yum.log')
    yumconf.set('main','pkgpolicy','newest')
    yumconf.set('main','tolerant','1')

cfile = file('/etc/yum.conf','w')
yumconf.write(cfile)
